<% 
' -----------------------------------------------------------------------------
'				Alfred Homeseer Integration Control Panel script
'					More info: www.domoticaworld.com
' 0.5  2012-April-22	Fixed bugs, changed test box, first published release
' 0.4  2012-March-30	Many addon's and bugfixes, 
' 0.3  2012-March-xx	Improvements, fixes, added help, added "RUN" button + test frame
' 0.2  2012-March-17	Add "add row" button, remove items, 
' 0.1  2012-March-16	Based on DJ_ControlPanel_07.asp 
' TODO: 'dry run' mode where you type text and it will tell you which entry it chose?
' -----------------------------------------------------------------------------
%>
<html>
<head>
<title>Alfred Homeseer Integration</title>
<script type="text/javascript" language="javascript">
function submitFormToIFrame(){
    //IE
    if( document.myform ){
        document.myform.setAttribute('target','frame_x');
        document.myform.submit();
    //FF
    } else {
        var form=document.getElementById('myform');
        form.setAttribute('target', 'frame_x');
        form.submit();
    }
}
</script>
</head>
<body>
<%
strDebug=0
strCounter = 1
strContinue = 1
strKeyword = "KeyW"
varVersion = "0.5"
strINIfile = "DJ_Alfred.ini"
strScriptName = hs.GetINISetting("Settings","ControlPanel","ERROR!",strINIfile)
strScriptAlfred = hs.GetINISetting("Settings","MainScript","ERROR!",strINIfile)


Response.Write  hs.GetPageHeader("Alfred Configuration","","",False,False,False,False,False)

CounterRF=1 '======================================================================== REMOVE
While hs.GetINISetting("CommandList",strKeyword & CounterRF,0,strINIfile) <> "0" and Request.Form("remove")<>"" 
	strWriteRemove = Request.Form("remove")
	if strDebug>0 then Response.Write "<b>REMOVE:</b> entry:" & strWriteRemove & "<br>"
	strWriteData = hs.GetINIsetting("CommandList",strKeyword&CounterRF, "", strINIfile	)
	if strDebug>0 and CounterRF=Cint(strWriteRemove) then Response.Write "DON'T WRITE entry " & CounterRF & "<br>"
	if strDebug>0 and CounterRF<Cint(strWriteRemove) then Response.Write "WRITE entry " & CounterRF & "<br>"
	if strDebug>0 and CounterRF>Cint(strWriteRemove) then Response.Write "WRITE entry-1 " & CounterRF-1 & "<br>"

	''If CounterRF=Cint(strWriteRemove) then Response.Write "DON'T WRITE entry " & strWriteRemove & "<br>"
	If CounterRF<Cint(strWriteRemove) then hs.SaveINISetting "CommandList",strKeyword & CounterRF, strWriteData, strINIfile
	If CounterRF>Cint(strWriteRemove) then hs.SaveINISetting "CommandList",strKeyword & CounterRF-1, strWriteData, strINIfile
	CounterRF = CounterRF + 1
Wend
If Request.Form("remove")<>"" then 
	if strDebug>0 then Response.Write "<b>REMOVE</b> last line ("&Cstr(CounterRF)&"<br>"
	hs.SaveINISetting "CommandList", strKeyword&CounterRF-1, Null, strINIfile
End if

CounterRF=1 '======================================================================== ADD
While hs.GetINISetting("CommandList","KeyW" & CounterRF,0,strINIfile) <> "0" and Request.Form("add")<>"" 
	CounterRF = CounterRF + 1
Wend
If Request.Form("add")<>"" then 
	If strDebug>0 then Response.Write "<b>ADDING</b> entry <br>"
	hs.SaveINISetting "CommandList", strKeyword&CounterRF, ",,,,", strINIfile
End if

CounterRF=1 '======================================================================== SAVE
While hs.GetINISetting("CommandList",strKeyword & CounterRF,0,strINIfile) <> "0" and Request.Form("action")="save" 
	If strDebug>0 then Response.Write "<b>ADD</b> entry <br>"
	If strDebug>1 then Response.Write "<b>ADD</b> entry <br>"
	strWriteData = Request.Form("Keyword"&CounterRF) & "," & Request.Form("Command"&CounterRF) & "," & Request.Form("Device"&CounterRF) & "," & Request.Form("Execute"&CounterRF) & "," & Trim(Request.Form("Return"&CounterRF))
	hs.SaveINISetting "CommandList",strKeyword & CounterRF, strWriteData, strINIfile
	CounterRF = CounterRF + 1
Wend

CounterRF=1 '======================================================================== TOGGLE DEBUG
If Request.Form("toggledebug")<>"" then
	debugCurrent = hs.GetINIsetting("Settings","Debug", 9, strINIfile)
	If debugCurrent = 1 then debugNew = 0
	If debugCurrent = 0 then debugNew = 1
	hs.SaveINIsetting "Settings","Debug", debugNew, strINIfile
End if
	



Response.Write "<br><table><td width='25px' rowspan='99'></td><tr><td colspan='9' class='tableheader'>Alfred Settings  <div style='font-size: 8pt;'>Controlpanel v"&varVersion&" ... Script v0." & hs.stringitem(hs.stringitem(strScriptAlfred,3,"_"),1,".") & "</div></td></tr>"
Response.Write "<tr class='tablecolumn'><td colspan='1'> </td><td>Entry</td><td>Keyword</td><td>Command</td><td>Device</td><td>Execute</td><td>Return</td><td>Run</td>"
Response.Write "<td style='font-weight:normal;' rowspan='50' valign='top'><br><b><u>Execute</u></b><br>switch<br>toggle<br>event<br>ir<br><br><b><u>Return</u></b><br>status<br>devicename<br>value<br>device(ID)<br>string<br>action<br>eventname<br><br><u>@r</u><br>New line<br><br><u>@sDEVICE</u><br>device STRING<br><br><u>@vDEVICE</u><br>device VALUE<br><br><br><br><input type='button' id='butDebug' class='formbutton' value='Toggle Debug' onclick='location.href=""../Alfred/" & strScriptName & "?toggledebug=1""' /><br><font color=gray>debug= " & hs.GetINIsetting("Settings","Debug", 9, strINIfile) & "</font><br></td></tr>"
Response.Write "<form method='post' action='" & strScriptName & "?action=save'>"

Do While strContinue = 1
	If strCounter MOD 2 = 0 Then Response.Write "<tr class='tablerowodd'>"
	If strCounter MOD 2 > 0 Then Response.Write "<tr class='tableroweven'>"
	strKeywordTemp = strKeyword + Cstr(strCounter)
	If strDebug>0 then Response.Write "<b>ADD</b> entry <br>"
	If strDebug>0 then Response.Write  "strKeywordTemp: " & strKeywordTemp & "<< <br>"
	strSection = hs.GetINISetting("CommandList",strKeywordTemp,"",strINIfile)
	If strSection="" then 
		strContinue=0
		Exit Do
	End if
	strItems = split(strSection,",")
	iniKeyword = Ucase(strItems(0))
	iniCommand = Ucase(strItems(1))
	iniDevice  = Ucase(strItems(2))
	iniExecute = Ucase(strItems(3))
	iniReturn  = strItems(4)
	If strDebug>0 then Response.Write  "iniKeyword: " & iniKeyword & "<< <br>"
	If strDebug>0 then Response.Write  "iniCommand: " & iniCommand & "<< <br>"
	If strDebug>0 then Response.Write  "iniDevice: " & iniDevice & "<< <br>"
	If strDebug>0 then Response.Write  "iniExecute: " & iniExecute & "<< <br>"
	
	Response.Write "<td> <a href='"+strScriptName+"?remove=" & strCounter & "'><img src='remove.gif'/></td>"
	Response.Write "<td width=40>" & strCounter & "</td>"
	Response.Write "<td><input type='Text' name='Keyword" & strCounter & "' size='8' class='formtext' value='" & iniKeyword & "'></td>"			
	Response.Write "<td><input type='Text' name='Command" & strCounter & "' size='8' class='formtext' value='" & iniCommand & "'></td>"	
	Response.Write "<td><input type='Text' name='Device" & strCounter & "' size='10' class='formtext' value='" & iniDevice & "'></td>"	
	Response.Write "<td><input type='Text' name='Execute" & strCounter & "' size='7' class='formtext' value='" & iniExecute & "'></td>"	
	Response.Write "<td><input type='Text' name='Return" & strCounter & "' size='40' class='formtext' value='" & iniReturn & "'></td>"	
	Response.Write "<td> <a href='/Alfred/" & strScriptAlfred & "?query=" & iniKeyword & " " & iniCommand & "' target='frame_x'><img src='button_run.gif'/></td>"
	Response.Write "</tr>"
	strCounter = strCounter + 1
Loop
Response.Write "</table><br>"


%>
</table>
<table>
	<tr>	<td rowspan="6" style="width:100px"></td> </tr>
	<tr>
	<td valign="top">
		<input type='button' id='butTest' class='formbutton' value='&nbsp;&nbsp;&nbsp;ADD row&nbsp;&nbsp;&nbsp;' onclick='location.href=""../Alfred/" & strScriptName & "?add=1""' /></td>
	<td valign="top" width="100"><input type='submit' name='newform' value='&nbsp;&nbsp;&nbsp;SAVE&nbsp;&nbsp;&nbsp;' class='formbutton' /> </form></td> 
	<td><form id='myform' name='myform' action='/Alfred/<% Response.Write strScriptAlfred %>' target=''>	
			home + <input type='Text' name='query' size='50' class='formtext' value=''>	
			<input type='button' value='Execute' onClick='submitFormToIFrame();'>
		</form>	
	</td></tr>
	<tr><td colspan="3">
		<span id='iframeSlot'>
			<iframe name='frame_x' width="600" height="250"></iframe>
			<br><font color=gray><% Response.Write strScriptAlfred %></font><br>
		</span>
	</td>
	</tr>
</table>
