<%@ Language=VBScript %>
<% 
'----- Homeseer Alfred Integration ----- 
'   more info: www.domoticaworld.com
' 0.10 - 2012-Apr-22 - Cleaned up code for beta publishing, added remove HTML code
' 0.9 - 2012-apr-06 - Fixed bugs, added IR
' 0.8 - 2012-mar-20 - Add multiple devices in string
' 0.7 - 2012-mar-15 - cleaned up code, fixed bugs, added docs
' 0.6 - 2012-mar-14 - Next..
' 0.5 - 2012-mar-12 - Added debug, cleaned up code
' 0.4b2 - 2012-mar-10 testing INI reading & processing in separate thread
' 0.4 - 2012-mar-10 - Testing ini file section read (failing!)
' 0.3 - 2012-mar-02 - started with functionality, not thinking about ini files yet
' 0.2 - 2012-mar-01 - changed information that is returned
' 0.1 - 2012-feb-26 - first release
' TODO
'	- Keyword: DEBUG ON/OFF, TABLE ON/OFF, TABLE, 
'	- BUG: PARAMETERS (devices) that you enter containing \ backslash
'---------------------------------------
varINIfile = "DJ_Alfred.ini"
varVersion = "DJ_Alfred_0.10"
dim strParameters
dim strDebug
dim strItems
dim strKeyword 
dim strSection
dim strCounter, strCounterFound
dim ReturnData
dim ReturnTable
dim CurrentCommand
dim iniCommandList
strKeyword = "KeyW"
strParameters = Request.Form("query")
parKeyword = Ucase(hs.stringitem(strParameters,1," "))
parCommand = Ucase(hs.stringitem(strParameters,2," "))
parDevice  = Ucase(hs.stringitem(strParameters,3," "))

dimExecute = ""
dimEvent   = ""
strCounter = 1
strContinue = 1
strTable = hs.GetINISetting("Settings","Table","0",varINIfile)
'DJ: Below check browser type. Only if called from Alfred, don't show table
strBrowser = Request.ServerVariables("HTTP_USER_AGENT")
If strBrowser="" then strTable=0

If parKeyword="INI" then	'---------------- INI
	strContinue=0
	strTable=0
	strCounterFound="ini"
	If parCommand="" or (parCommand<>"ON" and parCommand<>"OFF") then
		ReturnData = "ERROR: usage INI ON/OFF <br><br>"
		If strBrowser<>"" then strTable=1
		strContinue=1
	Else
		parCommand=(Replace(parCommand,"ON","1"))
		parCommand=(Replace(parCommand,"OFF","0"))
		ReturnData = hs.SaveINIsetting("Settings","Table", parCommand, varINIfile)
		ReturnData = "<font color=red>Changed INI settings to "+(Replace((Replace(parCommand,"0","OFF")),"1","ON"))+"</font><br>"
	End if
End if
If strTable=1 then ReturnTable = "<table border='1'><tr><th>INI</th><th>Keyword</th><th>Command</th><th>Device</th><th>Execute</th><th>Return</th></tr>"


If parKeyword="DEBUG" then	'---------------- DEBUG
	strContinue=0
	strTable=0
	strCounterFound="debug"
	If parCommand="" or (parCommand<>"ON" and parCommand<>"OFF") then
		ReturnData = "ERROR: usage DEBUG ON/OFF<br>"
	Else
		parCommand=(Replace(parCommand,"ON","1"))
		parCommand=(Replace(parCommand,"OFF","0"))
		ReturnData = hs.SaveINIsetting("Settings","Debug", parCommand, varINIfile)
		ReturnData = "<font color=red>Changed DEBUG settings to "+(Replace((Replace(parCommand,"0","OFF")),"1","ON"))+"</font><br>"
	End if
End if
strDebug = hs.GetINISetting("Settings","Debug","error",varINIfile)

If strDebug = 1 then Response.Write "<b>Script:</b> " + varVersion + " <br><b>DEBUG:</b> " + Cstr(strDebug) + " <br><b>Parameters</b> keyword: <font color=blue>"+parKeyword+"</font>....Command:<font color=blue>"+parCommand+"</font>....Device:<font color=blue>"+parDevice+"</font><br>"


Do While strContinue = 1
	strKeywordTemp = strKeyword + Cstr(strCounter)
	strSection = hs.GetINISetting("CommandList",strKeywordTemp,"",varINIfile)
	If strSection="" then 
		strContinue=0
		Exit Do
	End if
	strItems = split(strSection,",")
	iniKeyword = Ucase(strItems(0))
	iniCommand = Ucase(strItems(1))
	iniDevice  = Ucase(strItems(2))
	iniExecute = Ucase(strItems(3))
	iniReturn  = strItems(4)
	If strTable=1 then ReturnTable=ReturnTable+"<tr><td><font color=blue>"+strKeywordTemp+"</font></td><td>"+iniKeyword+"</td><td>"+iniCommand+"</td><td>"+iniDevice+"</td><td>"+iniExecute+"</td><td>"+iniReturn+"</td></tr>"
	
	' -- KEYWORD match
	iniCommandList = iniCommandList + iniKeyword + " <font color=blue>" + iniCommand + "</font> <font color=purple>" + iniDevice +"</font><br>"
	If strDebug > 0 then Response.Write Cstr(strCounter)+"--iniKeyword:" + iniKeyword + "... and parKeyword:" + parKeyword + "<br>"
	If iniKeyword=parKeyword then 
		If strDebug > 0 then Response.Write Cstr(strCounter)+"----OK! iniKeyword:" + iniKeyword + "... and parKeyword:" + parKeyword + "<br>"
		'-- COMMAND match (including EMPTY commands!)
		If iniDevice=""  and parDevice="" and iniCommand<>parCommand then 
			If strDebug > 0 then Response.Write Cstr(strCounter)+"------iniDevice=empty and parDevice=empty <br>"
			parDevice=parCommand	' (toggle,a14, becomes toggle,a14,a14)
			If iniCommand="" then parCommand=""
		End if
		If strDebug > 0 then Response.Write Cstr(strCounter)+"------ iniCommand=" & iniCommand & "  parCommand=" & parCommand & " <br>"
		If iniCommand=parCommand then
			If iniDevice<>"" and parDevice="" then parDevice=iniDevice
			If iniDevice<>"" and parDevice="" then Response.Write Cstr(strCounter)+"parDevice('"+parDevice+"')=iniDevice('"+iniDevice+"')<br>"			
			If strDebug > 0 then Response.Write Cstr(strCounter)+"-------- iniCommand=parCommand (" & iniCommand & "/" & parCommand & ") <br>"
			strCounterFound=strKeyword+Cstr(strCounter)
			If strDebug = 1 then Response.Write Cstr(strCounter)+"<b>INI match</b> keyword=<font color=blue>"+iniKeyword+"...</font>Command=<font color=blue>"+iniCommand+"...</font>Device=<font color=blue>"+parDevice + "</font><br>"
			If strDebug = 1 then Response.Write Cstr(strCounter)+"&nbsp;&nbsp;&nbsp;&nbsp;<font color=Red><b>COMMAND</b>: par='"+parCommand+"' and ini='"+iniCommand+"' match!</font><br>"
			'DJ: Run execute + return function
			If strDebug = 1 then Response.Write "ExecReturn("+parKeyword+","+parCommand+","+parDevice+","+iniExecute+","+iniReturn+")<br>"
			ReturnData = Cstr(ExecReturn(parKeyword,parCommand,parDevice,iniExecute,iniReturn))
		End if
	End If
	strCounter=strCounter + 1
Loop
If strCounterFound="" then ReturnData = ReturnData + "<font color=red>ERROR: Keyword "+parKeyword+" unknown.</font><br>Please use any of these commands:<br>" + iniCommandList


'DJ: Printing final results
If strDebug = 1 then Response.Write "<br>------------------------------------- <br>"
If strDebug = 1 then Response.Write "Debugging:<font color=blue> "+ Replace(Replace(strDebug,1,"ON"),0,"OFF")+"</font><br>"
If strDebug = 1 then Response.Write "Table:<font color=blue> " + (Replace((Replace(strTable,"0","OFF")),"1","ON"))+"</font><br>"
Response.Write ReturnData
If strDebug = 1 then Response.Write "------------------------------------- <br>"
If strTable=1 and strCounterFound <> "" then 
	ReturnTable=Replace(ReturnTable,strCounterFound&"<","<font color=red>"+strCounterFound+"</font><")+"</table>"
	Response.Write "<br>"+ReturnTable
End if

' ================================= END =================================

Function ExecReturn(parKeyword,parCommand,parDevice,iniExecute,iniReturn)
	If strDebug = 1 then Response.Write "&nbsp;&nbsp;&nbsp;&nbsp;-- Function Execute:<font color=blue>"+iniExecute+"</font><br>"
	Select Case iniExecute
			Case "SWITCH"
				CurrentCommand=parCommand
				If strDebug > 0 then Response.Write "----      hs.execX10("+parDevice+","+parCommand+")<br>"
				hs.ExecX10 parDevice, parCommand
			Case "TOGGLE"
				CurrentCommand=hs.StringItem(",OFF,ON",hs.DeviceStatus(parDevice),",")
				If strDebug > 0 then Response.Write "----      hs.toggleX10("+parDevice+") -- current status:"+StatusText(parDevice)+"<br>"
				hs.ExecX10 parDevice, hs.StringItem(",OFF,ON",hs.DeviceStatus(parDevice),",")
				If strDebug > 0 then Response.Write "----      hs.toggleX10("+parDevice+") --     new status:"+Cstr(hs.devicestatus(parDevice))+"<br>"
			Case "EVENT"
				If strDebug > 0 then Response.Write "----      hs.triggerevent("+parDevice+")<br>"
				hs.TriggerEvent parDevice
			Case "IR"
				'DJ-Todo: count number of "@", split by comma, then replace @ with comma and execute hs.sendir x times
				If strDebug > 0 then Response.Write "----      hs.sendir '"+parDevice+"' <br>"
				If strDebug > 0 then hs.writelog varVersion,"SendIr '"+Replace(parDevice,"@",",")+"'"
				hs.SendIr(Replace(parDevice,"@",","))
				CurrentCommand=Replace(parDevice,"@",",")
	End Select	
	If strDebug = 1 then Response.Write "&nbsp;&nbsp;&nbsp;&nbsp;-- Function Return:<font color=blue>" + iniReturn + "</font><br>"
	ExecReturn=ReplaceText(iniReturn,parDevice)

End Function

' ----------------------------------------------
Function RemoveHTML( strText )
	Dim RegEx
	Set RegEx = New RegExp
	RegEx.Pattern = "<[^>]*>"
	RegEx.Global = True
	RemoveHTML = RegEx.Replace(strText, "")
	RemoveHTML = Replace(RemoveHTML,"&nbsp;","")
End Function

' ----------------------------------------------
Function ReplaceText(input,device)
	TempText= Replace(input,"status",StatusText(device))
	TempText= Replace(TempText,"devicename",GetDeviceName(device))
	TempText= Replace(TempText,"value",Cstr(hs.devicevalue(device)))
	TempText= Replace(TempText,"device",device)
	TempText= RemoveHTML(Replace(TempText,"string",hs.devicestring(device)))
	TempText= Replace(TempText,"action",CurrentCommand)
	TempText= Replace(TempText,"eventname",parDevice)
	TempText= Replace(TempText,"@r","<br>")
	TempText= ReplaceValue(TempText)
	ReplaceText = TempText
End Function

' ----------------------------------------------
Function ReplaceValue(input)
	tempDebug = 0
	TempText = input	
	If tempDebug=1 then Response.Write "input:"+input+"<br>"
	For i=1 to ubound(split(TempText, "@s")) ' ============================== STRING
			If tempDebug=1 then Response.Write "i="+Cstr(i)+"<br>"
		replaceDeviceS = hs.stringitem(hs.stringitem(TempText,2,"@s"),1," ")
			If tempDebug=1 then Response.Write "String_device=" + replaceDeviceS + "<br>"
		If i<ubound(split(TempText, "@s")) then
			TempText = Replace(TempText,"@s"+replaceDeviceS+" ",hs.devicestring(replaceDeviceS)+" ")
		Else
			TempText = Replace(TempText,"@s"+replaceDeviceS,hs.devicestring(replaceDeviceS))
		End if
			If tempDebug=1 then Response.Write "== Replace String -->" + TempText + "<br>" 
	Next
	For i=1 to ubound(split(TempText, "@v")) ' ============================== VALUE
		replaceDeviceV = hs.stringitem(hs.stringitem(TempText,2,"@v"),1," ")
			If tempDebug=1 then Response.Write "Value_device=" + replaceDeviceV + "<br>"
		divideBy = 1
		If instr(replaceDeviceV,"/")>1 then
			divideBy = Cint(hs.stringitem(replaceDeviceV,2,"/"))
			If tempDebug=1 then Response.Write "--- DIVIDE BY found == " + cstr(divideBy) + "<br>"
			If tempDebug=1 then Response.Write "--- Value=" + Cstr(hs.devicevalue(replaceDeviceV)) + "... result:" + cstr(hs.devicevalue(replaceDeviceV)/divideBy) + "<br>"
		End if
		TempText = Replace(TempText,"@v"+replaceDeviceV+" ",Cstr(hs.devicevalue(replaceDeviceV)/divideBy)+" ")
			If tempDebug=1 then Response.Write "== Replace Value -->" + TempText + "<br>"
	Next
	ReplaceValue = TempText
End Function



' ----------------------------------------------
Function StatusText(StatusDevice)
	StatusCode=hs.devicestatus(StatusDevice)
	If StatusCode = "2" then StatusText = "ON"
	If StatusCode = "3" then StatusText = "OFF"
	If StatusCode = "4" then StatusText = "DIM"
	If StatusCode = "17" then StatusText = "UNKNOWN"
End Function
' ----------------------------------------------
function GetDeviceName(sDeviceCode)
	dim iRef
    iRef = hs.DeviceExistsRef(sDeviceCode)
    if iRef > -1 then
        GetDeviceName = hs.GetDeviceByRef(iRef).name
    else
        GetDeviceName = "Unknown"
    end if
end function

' ================= END ====================
%>
